Only in dmtcp/dmtcp: config.log
Only in dmtcp/dmtcp: config.status
Only in dmtcp/dmtcp: Makefile
Only in dmtcp/dmtcp/src: config.h
Only in dmtcp/dmtcp/src: connectionidentifier.o
Only in dmtcp/dmtcp/src: connectionmanager.o
Only in dmtcp/dmtcp/src: connection.o
Only in dmtcp/dmtcp/src: connectionrewirer.o
Only in dmtcp/dmtcp/src: connectionstate.o
Only in dmtcp/dmtcp/src: .deps
Only in dmtcp/dmtcp/src: dmtcpawareapi.o
Only in dmtcp/dmtcp/src: dmtcpaware.o
Only in dmtcp/dmtcp/src: dmtcp_checkpoint
Only in dmtcp/dmtcp/src: dmtcp_checkpoint.o
Only in dmtcp/dmtcp/src: dmtcp_command
Only in dmtcp/dmtcp/src: dmtcp_command.o
Only in dmtcp/dmtcp/src: dmtcp_coordinator
Only in dmtcp/dmtcp/src: dmtcpcoordinatorapi.o
Only in dmtcp/dmtcp/src: dmtcp_coordinator.o
Only in dmtcp/dmtcp/src: dmtcphijack.so
Only in dmtcp/dmtcp/src: dmtcp_inspector
Only in dmtcp/dmtcp/src: dmtcp_inspector.o
Only in dmtcp/dmtcp/src: dmtcpmessagetypes.o
Only in dmtcp/dmtcp/src: dmtcp_nocheckpoint
Only in dmtcp/dmtcp/src: dmtcp_nocheckpoint.o
Only in dmtcp/dmtcp/src: dmtcp_restart
Only in dmtcp/dmtcp/src: dmtcp_restart.o
Only in dmtcp/dmtcp/src: dmtcpworker.o
Only in dmtcp/dmtcp/src: execwrappers.o
Only in dmtcp/dmtcp/src: glibcsystem.o
Only in dmtcp/dmtcp/src: jalloc.o
Only in dmtcp/dmtcp/src: jassert.o
Only in dmtcp/dmtcp/src: jbuffer.o
Only in dmtcp/dmtcp/src: jfilesystem.o
Only in dmtcp/dmtcp/src: jserialize.o
Only in dmtcp/dmtcp/src: jsocket.o
Only in dmtcp/dmtcp/src: jtimer.o
Only in dmtcp/dmtcp/src: kernelbufferdrainer.o
Only in dmtcp/dmtcp/src: libdmtcpaware.a
Only in dmtcp/dmtcp/src: libdmtcpinternal.a
Only in dmtcp/dmtcp/src: libnosyscallsreal.a
Only in dmtcp/dmtcp/src: libsyscallsreal.a
Only in dmtcp/dmtcp/src: Makefile
diff -urw dmtcp_1.1.9-nomod/dmtcp/src/miscwrappers.cpp dmtcp/dmtcp/src/miscwrappers.cpp
--- dmtcp_1.1.9-nomod/dmtcp/src/miscwrappers.cpp	2010-09-19 04:55:05.000000000 +0900
+++ dmtcp/dmtcp/src/miscwrappers.cpp	2010-10-29 18:13:07.377008999 +0900
@@ -31,6 +31,7 @@
 #include "constants.h"
 #include "connectionmanager.h"
 #include "syscallwrappers.h"
+#include "sockettable.h"
 #include  "../jalib/jassert.h"
 #include  "../jalib/jconvert.h"
 
@@ -104,6 +105,12 @@
   // #endif
   //         dmtcp::SocketTable::instance().resetFd(fd);
   //     }
+
+  // Call an extra function on success.
+  if (!rv) {
+	  dmtcp_on_close(fd);
+  }
+
   return rv;
 }
 
Only in dmtcp/dmtcp/src: miscwrappers.o
Only in dmtcp/dmtcp/src: mtcpinterface.o
Only in dmtcp/dmtcp/src: nodetable.o
Only in dmtcp/dmtcp/src: nosyscallsreal.o
Only in dmtcp/dmtcp/src: pidwrappers.o
Only in dmtcp/dmtcp/src: protectedfds.o
Only in dmtcp/dmtcp/src: signalmanager.o
Only in dmtcp/dmtcp/src: signalwrappers.o
diff -urw dmtcp_1.1.9-nomod/dmtcp/src/sockettable.cpp dmtcp/dmtcp/src/sockettable.cpp
--- dmtcp_1.1.9-nomod/dmtcp/src/sockettable.cpp	2010-09-19 04:55:05.000000000 +0900
+++ dmtcp/dmtcp/src/sockettable.cpp	2010-10-29 18:12:09.125008998 +0900
@@ -35,12 +35,88 @@
 #include "connectionmanager.h"
 
 
+SocketInfo sock_table[32];
+int sock_table_size = 0;
+
+
+void add_socket_info(int fd) {
+	  if (!sock_table_size) {
+		  memset(sock_table, 0, sizeof(sock_table));
+	  }
+
+	  // Register a new socket.
+	  sock_table[sock_table_size].fd = fd;
+	  sock_table_size++;
+}
+
+void set_socket_info_type(int fd, socket_type type) {
+	int idx = socket_info_index(fd);
+
+	if (idx >= 0)
+		sock_table[idx].type = type;
+	else
+		JWARNING (false)("Invalid FD");
+}
+
+void set_socket_info_local_port(int fd, uint port) {
+	int idx = socket_info_index(fd);
+
+	if (idx >= 0)
+		sock_table[idx].local_port = port;
+	else
+		JWARNING (false)("Invalid FD");
+}
+
+int set_socket_info_active(int fd, int active) {
+	int idx = socket_info_index(fd);
+
+	if (idx >= 0) {
+		sock_table[idx].is_active = active;
+		return 0;
+	}
+	else
+		return -1;
+}
+
+int socket_info_index(int fd) {
+	int i = 0;
+	int len = sizeof(sock_table) / sizeof(SocketInfo);
+
+	for (i = 0;i < len;i++) {
+		if (sock_table[i].fd == fd) {
+			return i;
+		}
+	}
+
+	return -1;
+}
+
+uint addr_port(const struct sockaddr *addr) {
+	struct sockaddr_in6 *addr_v6;
+	struct sockaddr_in *addr_v4;
+	struct sockaddr_storage *storage = (struct sockaddr_storage *) addr;
+
+	if (storage->ss_family == AF_INET) {
+		addr_v4 = (struct sockaddr_in *) addr;
+		return ntohs(addr_v4->sin_port);
+	} else if (storage->ss_family == AF_INET6) {
+		addr_v6 = (struct sockaddr_in6 *) addr;
+		return ntohs(addr_v6->sin6_port);
+	}
+
+	JWARNING (false)("Invalid socket family");
+	return 0;
+}
+
 ///
 ///called automatically after a successful user function call
 extern "C" int dmtcp_on_socket ( int ret, int domain, int type, int protocol )
 {
 
   JTRACE ( "socket created" ) ( ret ) ( domain ) ( type ) ( protocol );
+
+  add_socket_info(ret);
+
 //     dmtcp::SocketEntry& entry = dmtcp::SocketTable::LookupByFd(ret);
 //     entry.setDomain(domain);
 //     entry.setType(type);
@@ -56,6 +132,9 @@
 ///called automatically after a sucessful user function call
 extern "C" int dmtcp_on_connect ( int ret, int sockfd, const  struct sockaddr *serv_addr, socklen_t addrlen )
 {
+	set_socket_info_type(sockfd, CONNECTING);
+	set_socket_info_active(sockfd, 1);
+
 //     JASSERT(serv_addr != NULL)(serv_addr)(addrlen);
 //     dmtcp::SocketEntry& entry = dmtcp::SocketTable::LookupByFd(sockfd);
 //     entry.setAddr(serv_addr,addrlen);
@@ -80,6 +159,9 @@
 ///called automatically after a sucessful user function call
 extern "C" int dmtcp_on_bind ( int ret, int sockfd,  const struct  sockaddr  *my_addr,  socklen_t addrlen )
 {
+	uint port = addr_port(my_addr);
+	set_socket_info_local_port(sockfd, port);
+
   dmtcp::TcpConnection& con = dmtcp::KernelDeviceToConnection::instance().retrieve ( sockfd ).asTcp();
 
 
@@ -100,6 +182,7 @@
 ///called automatically after a sucessful user function call
 extern "C" int dmtcp_on_listen ( int ret, int sockfd, int backlog )
 {
+	set_socket_info_type(sockfd, LISTENING);
 
   dmtcp::TcpConnection& con = dmtcp::KernelDeviceToConnection::instance().retrieve ( sockfd ).asTcp();
 
@@ -113,6 +196,10 @@
 ///called automatically after a sucessful user function call
 extern "C" int dmtcp_on_accept ( int ret, int sockfd, struct sockaddr *addr, socklen_t *addrlen )
 {
+	add_socket_info(ret);
+	set_socket_info_type(ret, LISTENING);
+	set_socket_info_active(ret, 1);
+
 //     dmtcp::SocketEntry& entry = dmtcp::SocketTable::LookupByFd(ret);
 //     entry.setAddr(addr,*addrlen);
 //     entry.setState(dmtcp::SocketEntry::T_ACCEPT);
@@ -199,6 +286,17 @@
   return ret;
 }
 
+// Called automatically after a successful user function call.
+extern "C" int dmtcp_on_close(int fd) {
+	int idx = socket_info_index(fd);
+
+	if (idx < 0)
+		return -1;
+
+	// If this "close" call comes from function "pre_ckpt", field
+	// "is_protected" will be 1. Do not mark it as inactive.
+	return sock_table[idx].is_protected ? 0 : set_socket_info_active(fd, 0);
+}
 
 ///
 /// autogenerated Set/Get method...
diff -urw dmtcp_1.1.9-nomod/dmtcp/src/sockettable.h dmtcp/dmtcp/src/sockettable.h
--- dmtcp_1.1.9-nomod/dmtcp/src/sockettable.h	2010-09-19 04:55:05.000000000 +0900
+++ dmtcp/dmtcp/src/sockettable.h	2010-10-29 17:44:59.541008999 +0900
@@ -26,6 +26,29 @@
 #include <sys/socket.h>
 
 
+typedef enum socket_type {
+	LISTENING = 1,
+	CONNECTING
+} socket_type;
+
+typedef struct SocketInfo {
+	int fd;
+	socket_type type;
+	uint local_port;
+	int is_active;
+	int is_protected;
+} SocketInfo;
+
+
+void add_socket_info(int fd);
+void set_socket_info_type(int fd, socket_type type);
+void set_socket_info_local_port(int fd, uint port);
+// Set field "active" of socket "fd". Return 0 if the field is successfully
+// set; -1, otherwise.
+int set_socket_info_active(int fd, int active);
+int socket_info_index(int fd);
+uint addr_port(const struct sockaddr *addr);
+
 
 #ifdef __cplusplus
 #define EXTERNC extern "C"
@@ -40,7 +63,7 @@
 EXTERNC int dmtcp_on_accept ( int ret, int sockfd, struct sockaddr *addr, socklen_t *addrlen );
 EXTERNC int dmtcp_on_error ( int ret, int sockfd, const char* fname );
 EXTERNC int dmtcp_on_setsockopt ( int ret, int sockfd, int  level,  int  optname,  const  void  *optval, socklen_t optlen );
-
+EXTERNC int dmtcp_on_close(int fd);
 
 
 #ifdef __cplusplus
@@ -50,6 +73,7 @@
 #include "dmtcpmessagetypes.h"
 #include  "../jalib/jbuffer.h"
 
+
 namespace dmtcp
 {
 //     class SocketEntry
Only in dmtcp/dmtcp/src: sockettable.o
Only in dmtcp/dmtcp/src: socketwrappers.o
Only in dmtcp/dmtcp/src: stamp-h1
Only in dmtcp/dmtcp/src: syscallsreal.o
Only in dmtcp/dmtcp/src: syslogcheckpointer.o
Only in dmtcp/dmtcp/src: uniquepid.o
Only in dmtcp/dmtcp/src: virtualpidtable.o
Only in dmtcp/dmtcp/src: workerhijack.o
